This file was last updated on April 1, 2009.

Significant changes associated with GraphicsMagick 1.1.15 (April 1, 2009)

  Bugs Fixed:

    o The MagickLibVersion define overflowed as of 1.1.10 since only
      one digit was reserved for the minor version.  Fixed now.

    o MSL: Fix for handling of geometry x,y values in association with
      gravity.

    o TIFF: Ping mode is now fast like it should have been.

    o Conjure subcommand was returning inverted status to the
      environment.

    o Benchmark subcommand was leaking memory for each iteration.

    o Magick++ Image color quantization error measurement was
      performing a wasteful operation.

    o GraphicsMagick.spec was not installing module .la files by default.

    o Bounding box query was failing rather than returning a bounding box
      matching the entire image if there was no subimage to bound.

    o Memory leak/use fixes.

  Security Fixes:

    o Exclude all virtual delegates and coders for pseudo-formats when
      deciding to use file extension as the format.

    o Fix assertion thrown for BMP and DIB files with negative image
      height values.

Significant changes associated with GraphicsMagick 1.1.14 (released June 5, 2008)

  Bugs Fixed:

    o Noise generation was not working correctly for anything but a Q8 build.

    o Poisson noise generator was extremely slow.  Now it is reasonably fast.

    o PDF reader now computes bounding box for rotated PDFs correctly.

  Security Fixes:

    o Cineon reader: Fixed crash with broken file from Sami Liedes.

    o PICT reader: Fixed crash with broken files from Sami Liedes.

    o XCF reader: Fixed crash with broken files from Sami Liedes.

  Security Issue Not Fixed:

    o JP2/JPC reader: Several JPEG-2000 files from Sami Liedes broken collection
      cause crashes in Jasper.  This is not GraphicsMagick's fault.

Significant changes associated with GraphicsMagick 1.1.13 (released May 28, 2008)

  Bugs Fixed:

    o Documentation is now installed according to the conventions established by
      the configure script.  This results in documentation being installed under
      /usr/local/share/doc/GraphicsMagick by default.

    o HWB colorspace now works correctly.

    o Composition with CopyOpacity now produces an image with
      transparency (as expected).

    o Composition now preserves the canvas colorspace.

    o Composition with a displacement map (-displace) no longer leaks an image.

    o Alpha composition now works as expected when both pixels involved
      include transparency.

    o -gamma multiple channel syntax now works as documented.

    o Now compiles with Visual C++ 2008.

Significant changes associated with GraphicsMagick 1.1.12 (released April 28, 2008)

  Security Fixes:

    o Do not access X11 or invoke convenience or stealth delegate
      programs based on the file extension. In particular, these file
      extensions are rejected for consideration as a format specifier:
      'autotrace', 'browse', 'dcraw', 'edit', 'gs-color',
      'gs-color+alpha', 'gs-gray', 'gs-mono', 'launch', 'mpeg-encode',
      'print', 'scan', 'show', 'win', 'xc', and 'x'.

  Bugs Fixed:

    o magick/effect.c: Should now compile for ARM CPU.

    o TIFF: Don't request Kodak private tags since these cause some
      versions of libtiff to misbehave.

    o When performing string expansion of image attribute identifiers, skip
      those which require access to image pixels if image pixels are not
      present.

    o CropImageToHBITMAP(), ImageToHBITMAP(): Fix leak of bitmap handle.

Significant changes associated with GraphicsMagick 1.1.11 (released February 23, 2008)

  Bugs Fixed:

    o BMP: Support large files.

    o DIB: Support large files.

    o PNG: Fix depth handling with 16-bit PNG files in the Q8 build.

    o SUN: Properly report image depth.

    o TIFF: Endian option (-endian) now controls TIFF byte endian order
      rather than bit fill order.

    o DCM, DIB, XBM, XCF, XWD: Eliminate integer overflow vulnerability
      (IDefense 09.19.07).

    o HSL colorspace transform: Avoid optimization bug noticed on Opteron
      with GCC.

    o HWB colorspace transform: Avoid optimization bug noticed on Opteron
      with GCC.

    o RGBTransformImage()/TransformRGBImage(): Was using HWB colorspace
      when HSL was requested.

    o Successfully reads files with names like 'file[123]'.

    o 'gm display': No longer rely on isatty() to determine if input is
      from a pipe (use 'gm display -' to display an image read from a pipe).

  Feature Improvements:

    o 'identify +ping' forces the pixels to be read (similar to GM 1.2).

    o 'gm -version' now indicates if build supports "Large Memory" (i.e. 64-bit).

    o TIFF: Use '-define tiff:fill-order={msb2lsb|lsb2msb}' to control
      TIFF bit fill order.


  Performance Improvements:

    o No longer bogs down if a directory contains hundreds of thousands of
      files and the filename looks like a wildcard specification.


Significant changes associated with GraphicsMagick 1.1.10 (released September 19, 2007)

  Bugs Fixed:

    o Image rotate by -90/270 degrees was producing wrong output.

Significant changes associated with GraphicsMagick 1.1.9 (released September 16, 2007)

  Bugs Fixed:

    o In mogrify command, don't remove file name based on random junk in
      memory.
    o Fixed memory leak when reading MPC files.
    o Fixed crash when writing MIFF format and depth is not expected 8/16/32/.
    o Find latest Ghostscript under Windows which identifies itself as
      "GPL Ghostscript".
    o In mogrify command, don't leak memory in the case where the image
      file contains multiple frames.
    o Fixed crash in PNG and JPEG coders when the image to be written is
      part of an image list.
    o PNG reader errors are now properly reported to the user.
    o TIFF output can now be written to a pipe or other non-seekable
      destination.
    o Support writing PDF with CCITT compression.

  Feature Improvements

    o Added a new 'benchmark' command which can be used to perform
      benchmarking on any other command.
    o Image rotate in clockwise (90 degrees) or counter-clockwise (270
      degrees) direction is now 2-9X faster than before.
    o The -version option now includes a list of supported features.
    o For Windows MinGW-based build, find Ghostscript fonts installed
      under C:/Program Files/.

Significant changes associated with GraphicsMagick 1.1.8 (released July 28, 2007)

  Security Fixes:

    o Shell command injection via delegates subsystem (CVE-2005-4601).
    o Insecure use of filenames as a "sprintf" specification (CVE-2006-0082).
    o EXIF IFD stack overflow vulnerability.
    o BMP  format: Verify seek before proceeding.
    o DCM  format: Buffer overflow prevention (CVE-2006-5456).
    o DCM  format: Integer overflow prevention (CVE-2007-1797).
    o PALM format: Heap overflow prevention (CVE-2006-5456).
    o SGI  format: Fixes for RLE decoding issue (CVE-2006-4144).
    o XCF  format: Buffer overflow prevention, infinite loop prevention.

  Bugs Fixed:

    o Typo when searching for HTMLDecodeDelegate.
    o Avoid crash if delegate program fails to return an image.
    o EXIF memory leak fixes.
    o Command parser memory leak fixes.
    o Deadlock fix for event log initialization.
    o Work with latest Ghostscript "GPL Ghostscript" under Windows.
    o 'gm import' now returns image of appropriate depth.
    o Fixed memory map resource managment.
    o Fixed includedir variable in pkg-config files.
    o Fixed validation of -affine argument.
    o Fixed bug where fseeko() and ftello() were not used when available.
    o Fixed issue when pread() and pwrite() prototypes are missing.
    o Fixed pixel cache issues when size_t is an unsigned type.
    o Fixed dcraw delegate options to work with modern dcraw.
    o Fixed -level argument parsing to allow embedded % characters.
    o Fix for segfault in InitializeMagick(NULL).
    o Fix for segfault in ModifyCache().
    o Fix for Wand MagickGetQuantumDepth() interface.
    o Fix for GrayscalePseudoClassImage() on 64-bit systems.
    o Fix for MagickReallocMemory memory leak under certain error conditions.
    o Validate BLOB access range.
    o ICON format: Segfault fix.
    o JPEG format: Fixed reading 12-bit grayscale JPEG.
    o MAT  format: Stability improvements.
    o MIFF format: Handle a compression value of 'None'.
    o PCX  format: Segfault fix.  Heap overflow fix.
    o PDF  format: Fixed writing with JPEG compression.
    o PICT format: Segfault fix.
    o PNG  format: Fixed compile problem with some libpng versions. Segfault fix.
    o PNM  format: Fixed scaling problem due to rounding error. Validate scaling.
    o PSD  format: Fixed memory leak with layerd PSD files.
    o SGI  format: Handle 16-bit SGI image files correctly.
    o SUN  format: Segfault fix.
    o TIFF format: Secure error reporting.  Finally support LZW under Windows.
    o WPG  format: Fixed crash with clip-art WPG files.
    o XWD  format: Fix for integer under/overflow.

  Feature Improvements

    o CIN format: Implementation is entirely replaced.
    o MAT format: Support Byte and Word formats, as well as big/little endian.
    o WPG format: Support for CTM translation.

  Updates:

    o JasPer is updated to version 1.900.1.
    o Jbigkit is updated to version 1.6
    o Lcms is updated to version 1.16
    o Libpng is updated to version 1.2.18
    o Libtiff is updated to version 3.8.2.

Significant changes associated with GraphicsMagick 1.1.7 (released October 12, 2005)

  Security Fixes:  
    o Updated zlib to version 1.2.3 (1.2.2 has a security flaw).

  Bugs fixed:
    o Fixed double-free problem while displaying an image with X.org
    server noted under FreeBSD 5.4 and heard about under Linux with X.org.
    o Fixed buffer over-run in readdir() which only occurs under
    Microsoft Windows.
    o Memory leak fixes for GIF and SVG.
    o Fix for an infinite loop bug in the XWD reader.
    o Properly DLL-export DispatchImage and PopImagePixels.

  Updates:
    o Zlib is updated to version 1.2.3.
    o Libpng is updated to version 1.2.8.

Significant changes associated with GraphicsMagick 1.1.6 (released May 1, 2005)

  Improvements:
    o Performance enhancements to internal string handling.
    o Save monochrome and grayscale flags in MPC format so that
    subsequent saving to a monochrome or grayscale format is faster.

  Bugs fixed:
    o Memory leak fix to IsPaletteImage().
    o Resource tracking (leak) fix to pixel cache code. After processing
    many images, GraphicsMagick started running slower due to incorrectly
    using a disk-based pixel cache rather than RAM.
    o Fixed assertion encountered when displaying a large image using
    MacOS's X11.
    o JBIG output was an empty file for some versions of libjbig.
    o PDF output no longer causes warnings with Ghostscript 8.5.
    o Added cast to double for integer arguments to pow() which seems
    necessary since Visual C++ 7.0 and later don't seem to understand
    that the argument to pow() is a double.
    o The -convolve option was not working.  Convolution was working at
    the API level.

  Security Fixes:

    o Defend against malevolent pnm "P7" files.

Significant changes associated with GraphicsMagick 1.1.5 (released January 22, 2005)

  Security Fixes:

    o Fixed vulnerability associated with reading PSD files. See
    http://lwn.net/Articles/119713/ for details.

  Incompatible changes:
    o The interpretation of -modulate's (and similar C/C++/Perl API) hue
    argument is altered since the previous definition did not work. Hue
    argument now represents a rotation from -180 degrees to +180 degrees
    expressed as an argument of 0 to 2.0 (1.0 for no change).
    o FlashPIX library sources are no longer distributed in the Windows
    source package and building FlashPIX is disabled by default.  FlashPIX
    may still be built by adding the library (separately distributed).

  Bugs fixed:
    o TrueColor 16-bits/sample RGB images were being written incorrectly
    on little-endian CPUs.
    o Ensure that data can not overwrite the stack in the Windows
    readdir/opendir emulation functions.
    o For BMP and DIB, properly handle oversized colormaps in order to
    avoid heap corruption.
    o Reading TIFFs with more than one strip was broken.
    o Obscure error-path memory leak fix for GIF coder.
    o Automatically discover Ghostscript fonts under latest Cygwin.
    o Gmdisplay now converts the image colorspace to RGB while reading
    so that it displays correctly.

  Improvements:
    o Handle JP2 images in YCBCR colorspace. Retrieve color profiles from
    JP2 images.
    o TGA coder now writes grayscale images if appropriate.
    o LCMS in Windows package updated to version 1.14.


Significant changes associated with GraphicsMagick 1.1.4 (released November 13, 2004)

  Security Fixes:
    * Security fixes for AVI, BMP, DIB, and TIFF formats.
    * Zlib security fix (updated Windows sources to use zlib 1.2.2).

  Bugs fixed:
    * Properly detect and handle errors from libtiff APIs while writing
    TIFF files which could result in corrupted output files. This fix is
    particularly important when the installed libtiff does not support
    LZW compression.
    * Fix writing 16-bit (or larger) grayscale TIFF on little-endian
    machines.
    * Better detect and report defective GIF files (sometimes crashed due
    to bad access).
    * Ensure that MIFF files indicate the compression type which was
    actually used.
    * Eliminate warning regarding module registration which occured for
    JNG in some build configurations (when libjpeg was missing).
    * Documentation fixes.

  Improvements:
    * Display GraphicsMagick logo rather than ImageMagick logo in
    'display' Commmands widget.
    * TclMagick updated to latest version.
    * Use latest Automake (1.9.3).
    * Libpng updated. Updated Windows sources to use libpng version 1.2.7.

Significant changes associated with GraphicsMagick 1.1.3 (released August 7, 2004)

  Bugs fixed:
    * PNG fixes for CERT security alert TA04-217A described at
    "http://www.us-cert.gov/cas/techalerts/TA04-217A.html".
    * Take resolution units into consideration when resampling an image.
    * If image units are changed, rescale existing image resolution values
    to match.
    * Fixed problems with reading and writing large PCX files.
    * Fixed crash in Wand library MagickSetPassphrase().
    * When a Wand library function is used for which a backing
    implementation does not yet exist, report a "not implemented" error
    rather than just returning an error status.
    * Fixed a problem when reading some BMP v4 files.
    * DESTDIR install now works properly with PERL 5.8.1 and later.

  Improvements:
    * Support reading RGB/CMYK scanline oriented TIFF images with arbitrary
    depth.
    * LZW support for GIF and TIFF is enabled by default.
    * Incorporated lcms 1.13 for more speed, and bug-fixes.
    * The configure script now looks for mozilla (or firebird) when looking
    for a web browser.  Netscape is used if mozilla or firebird are not present.

Significant changes associated with GraphicsMagick 1.1.2 (released June 6, 2004)

  Bugs fixed:
    * The source RPM package was not installing the *-config scripts with
    execute permissions.
    * Under Windows, the Ghostscript fonts were not being found for
    Ghostscript 8.X.X installs.
    * For the "moby" (shared, non-module) build, loading all modules was
    reporting an error while running the test suite due to not locating the
    LOGO module.  The "moby" build was not really able to load external
    modules at all.
    * Fixed building under the current MinGW development environment.
    * Fixed usage message for `mogrify' (was missing -operator).
    * Fixes for SetImageOpacity().

  Improvements:
    * Significant performance improvments (4X) in DispatchImage() and
    ConstituteImage() for byte-sized input/output and the patterns BGR,
    BGRO, BGRP, RGB, RGBO, and I.
    * The module loader now properly considers the module loading path in
    all cases.  This means that modules may be located in multiple directories
    and the user may supply his own modules in some other location.  Module
    loading now works as intended for the "moby" build even though the
    standard modules are included in the GraphicsMagick shared library or DLL.
    * Under Windows, initialization time should be somewhat improved while
    loading the type.mgk (font description) file.

Significant changes associated with GraphicsMagick 1.1.1 (released May 2, 2004))

  Bug fixes:
    * Fixed a strtod/scanf bug with parsing some arguments starting with
    "0x" under Linux.
    * Fixed a double-free bug in the display program.
    * GraphicsMagick now successfully builds and passes all tests under
    Digital Unix 5.1, using the vendor compiler.
    * Ghostscript sometimes displays an error message and fails, yet it
    returns a success error code to GraphicsMagick. Verify that
    Ghostscript has updated the output file before attempting to use it.
    * Eliminated an out of bounds array access in HuffmanEncode2Image().
    * Fixed a configure script syntax error when testing for trio.

  Utilities enhancements:
    * If gm is executed under a traditional alternate name (e.g.
    convert), it will invoke the appropriate sub-command. This allows use
    of hard links, symbolic links, or just copying 'gm' to the desired
    sub-command name in order to achieve 100% ImageMagick 5.5.2 utility
    compatibility.
    * Provide the --enable-magick-compat option when configuring to install
    ImageMagick utilities compatibility links.

Significant changes associated with GraphicsMagick 1.1 (released April 4, 2004)

  Bug fixes:
    * Semaphore fix which is necessary for proper multi-threaded operation.
    * Configure script fix to ensure that -lfpx is not supplied to the C
    compiler during subsequent tests since this fails on some systems.
    * Fix for East and West gravity computations.
    * System error reports (errno) associated with an exception are now
    correctly obtained from the context existing when the exception was
    thrown rather than the context of the reporting function.
    * JNG encoder fix. Files were being written with incorrect
    alpha_sample_value in the header. These can be repaired by reading
    them into GM 1.1 and rewriting them.
    * XPM fix to module registration.
    * PSD fix for index calculation when QuantumDepth>8.
    * Validate that geometry specifications only include allowed
    characters.
    * SGI fix to save compression type while writing.
    * EXIF attributes were not being retrieved when requested.
    * Fix for bug when reading an image via a user-provided file
    descriptor.
    * The reported image magick string is now always that of the original
    input file (it was sometimes being reported as the format produced by
    an intermediate delegate program).
    * Fixes to color profiling of CMYK images.
    * Memory leak fixed in DrawClipPath().
    * Arc drawing is fixed.
    * Command-line parsing bug under Linux due to Linux's sscanfs
    inability to parse strings like "0x1" as "%fx%f" is fixed.
    * Scaling of 5 and 6-bit colors was slightly incorrect in BMP, AVI,
    DIB, and TIM datastreams.
    * GM utility now reports an error rather than silently returning if
    an unsupported sub-command is provided.

  Performance improvements:
    * Texture tiling is now 7X faster.
    * Color profile processing speed improvements for colormapped images.

  Utilities enhancements:
    * For Unix, 'gm version' now includes a dump of the configure and
    build parameters.
    * Logging of thrown exceptions is now supported. Use '-debug
    exception'. This is useful to learn when and where errors are
    reported.
    * The -define option is added in order to support supplying
    additional options to coders without needing to add additional
    command line options or structure members.
    * The output of 'gm identify -verbose' now provides a nice dump
    of EXIF data.
    * The -sampling-factor option now accepts as many HxV pairs as
    there are JPEG components.  Omitted ones default to 1x1.
    * The convert and montage commands now support an -operator command to
    perform arithmetic and bitwise operations on specified image channels.

  Coder additions/improvments
    * The META coder supports wide characters for the IPTC and 8BIM
    formats.
    * The XTRN coder now supports wide characters.
    * An "IMAGE" coder is provided which provides access to a large
    number of images (derived from XFig) suitable for use as patterns,
    or as test images.
    * The "PATTERN" coder now returns an image pattern tiled to size
    (equivalent results to TILE:IMAGE:pattern). This is for ImageMagick
    compatibility.
    * The CINEON coder now supports reading and writing images in CINEON
    "CIN" linear gray and RGB formats. The read support is still very
    weak, but it works for common images.
    * The JPEG coder now estimates the original JPEG quality and sampling
    factors and will reuse these options when writing JPEG if the image
    is of the same type and the option "-define JPEG:preserve-settings"
    is supplied.
    * The JPEG-2000 coder now supports all Jasper library arguments using
    command line syntax similar to '-define jp2:rate=0.5'.
    * Reading and writting compressed SVG (SVGZ) is now supported.
    * The TXT coder now observes depth when writing.
    * The TIFF coder now outputs colormapped images with 1, 2, 4, and 8
    bits per sample in order to provide much smaller file sizes for
    images with very few colors.
    * Many TIFF coder enhancements. Now reads colormapped and grayscale
    images at arbitrary (even odd) bits-per-sample sizes. Now properly
    supports an opacity channel (at any bits-per-sample value) for
    grayscale images. Bilevel grayscale images are treated similar to any
    other grayscale image unless CCITT FAX3/FAX4 compression is
    requested. Now allows the user to specify an arbitrary
    bits-per-sample value for grayscale images (even odd values) using
    "-define tiff:bits-per-sample=value". Now automatically stores the
    image as TrueColor RGB pixels if the image compression is set to JPEG.
    TIFF files are now written in using the TIFF library's default endian
    order rather than always big endian.
    * The WPG coder now renders embedded WMFs.
    * The PS3 coder is completely re-written to work much better and
    support more features (see ChangeLog).

  Code structure enhancements:
    * Error handling has been improved and validated through testing.
    Some errors were being lost, unnecessarily ignored, or reported as
    something else entirely.
    * The number of error text messages to be maintained has been reduced
    by consolidating similar messages.
    * The memory allocator functions have been replaced with similar
    macros in order to eliminate warnings with GCC 3.3, avoid
    accidentally casting away const, and allow memory debuggers to
    report memory allocations and frees against the correct functions.
    The previously-used functions remain in the library for the purpose
    of compatibility.
    * <magick/xwindow.h> no longer depends on magick_config.h defines.
    * The text string localization code has been replaced with a simpler
    version written by Bill Radcliffe.
    * Added key,value "map" APIs (somewhat similar to C++'s <map>) for
    internal use.

  API enhancements:
    * Incorporated John Cristy's Wand API's in a new GraphicsMagickWand
    library.
    * API definition is no longer dependent on types which vary in size
    (e.g. size_t) depending on large file compilation options.  This means
    that applications may now be compiled without any special large file
    options and still work properly with the library.
    * Thrown exceptions (ExceptionInfo structure) now include source
    file, source line, function name, and current system error number.
    * The GetMagickInfoArray() function is added to replace use of
    GetMagickInfo() for code which needs to access the coder list. This
    is necessary since invoking GetMagickInfo() may re-order the coder
    list, causing problems for code which traverses the list. Using
    GetMagickInfo() to access individual list elements is safe.
    * Added the CopyException function to support copying exception info
    from one structure to another.
    * Added the ReplaceImageInList function to replace an image in an
    image list.
    * Added the DrawPeekGraphicContext function to access the current
    DrawInfo structure in the drawing context stack. Use of this
    function is not recommended since it voilates proper programming
    practices. It is added to support the Wand API's.
    * GetImageDepth() now returns an integral value between 1 and
    QuantumDepth and is no longer limited to the values 8, 16, and 32.
    * SetImageDepth() supports setting the image modulus depth to any
    integral value between 1 and QuantumDepth. This effects the effective
    numeric precision, not the storage depth, since the quantum storage
    type is still a Quantum.
    * GetImageChannelDepth() supports retrieving the modulus depth for a
    specified channel.
    * SetImageChannelDepth() supports setting the modulus depth for a
    specified channel.
    * ProfileImage is updated to handle alpha channels and grayscale
    images.
    * Added GetImageProfile() to retrieve a CMS profile from an image.
    * Added SetImageProfile() to attach a CMS profile to an image without
    adjusting the image pixels.
    * Added DeleteImageProfile() to remove a CMS profile from an image.
    * ConstituteImage() and DispatchImage() now support 'T' (transparency),
    'O' (opacity), and 'P' (pad) options.
    * CompositeImage() now supports CopyCyanCompositeOp,
    CopyMagentaCompositeOp, CopyYellowCompositeOp, and
    CopyBlackCompositeOp, composition operators.
    * GetColorHistogram() obtains a color histogram for the image.
    * QuantumOperatorImage() and QuantumOperatorRegionImage() support
    arithmetic and bitwise operations on specified image channels.
    * The semaphore.h header is no longer installed or included in the
    API headers since these functions are private interfaces.
    * Configure using --enable-symbol-prefix or define
    PREFIX_MAGICK_SYMBOLS to use the C preprocessor to prefix all library
    symbols with "Gm". This prevents library symbol conflicts with other
    libraries.

  PerlMagick fixes:
    * Adjusted a number of function option names so that they match the
    documentation.
    * Memory leak fixed.
    * Reading files (e.g. GIF) via a file descriptor is fixed.

  Build improvements:

    * The TRIO library may be used to provide a replacement for vsnprintf
    if the C library doesn't provide it.  This improves security on old
    systems.
    * Configure only configures for C & C++ languages.
    * Configure now does a better job of figuring out how to build a
    thread-safe library across multiple operating systems.
    * Configure incorporates a new mmap() test which tests the
    functionality which is needed so that mmap() is not unnecessarily
    rejected on a number of systems. This improves performance for large
    files on those systems.
    * Configure/build fixes for IBM's AIX operating system.

  Windows-specific improvements:
    * The static install package now uses the "uninstalled"
    configuration so that it does not depend on the Windows registry in
    order to run. This allows files from the static install package to
    be copied to another computer without running an installer.
    * The executable search path is extended at run-time to include the
    directory where the CORE DLLs reside in order to ensure that they
    are found.
    * Adding the -t option to VisualMagick configure enables building
    all of the coders into one library in order to save build time and
    simplify linkage.
    * The XTRN coder now supports wide characters.
    * LCMS library updated to version 1.10.
    * GMDisplay displays a checkerboard pattern behind transparent images.
    * Support is provided for issuing log messages to the Windows standard
    logging system.
    * Project files are now provided for use with Borland C++ Builder 6.0.
    * Updated LCMS version to 1.12.
    * Updated FreeType version to 2.1.5.
    * Updated JBIG-KIT to version 1.5.
    * Updated libpng to version 1.2.5.
    * Updated libwmf to version 0.2.8.2.
    * Updates zlib to version 1.2.1.
    * ActivePerl 5.8.1 Build 807 now supported.
    * GraphicsMagick now compiles using Visual Studio .NET 2003.

---------------------------------------------------------------------------
Significant changes associated with GraphicsMagick 1.0 (Released in May, 2003)

  GraphicsMagick support services:
    * Master web site at "http://www.GraphicsMagick.org/".
    * Mailing lists, bug tracking, and forums available via
    "http://sourceforge.net/projects/graphicsmagick/".
    * CVSWeb via "http://cvs.graphicsmagick.org/cgi-bin/cvsweb.cgi/".
    * CVS via cvs.graphicsmagick.org (find instructions at
    "http://www.graphicsmagick.org/www/cvs.html").
    * FTP via "ftp://ftp.graphicsmagick.org/pub/GraphicsMagick".

  Project maintenance improvements:
    * ChangeLog conforms to the GNU standard and all CVS commits include
    useful log messages.
    * CVS commit messages posted to graphicsmagick-commit mail list.
    * CVS commit messages contain CVSWeb URL references.

  Footprint changes from ImageMagick:
    * Library -lMagick renamed to -lGraphicsMagick.
    * Library -lMagick++ renamed to -lGraphicsMagick++.
    * Utilities consolidated into a single 'gm' utility (e.g. use 'gm
    convert').
    * Script Magick-config renamed to GraphicsMagick-config.
    * Script Magick++-config renamed to GraphicsMagick++-config.
    * Headers installed under ${PREFIX}/include/GraphicsMagick.
    * PerlMagick namespace renamed from "Image::Magick" to "Graphics::Magick".
    * Pkgconfig files GraphicsMagick.pc and GraphicsMagick++.pc are
    installed in $libdir/pkgconfig to assist pkg-config users.
    * Coder modules installed to lib/GraphicsMagick-1.0/modules-Q8/coders.
    * Filter modules installed to lib/GraphicsMagick-1.0/modules-Q8/filters.

  Many performance enhancements:
    * Default QuantumDepth is 8 since this is adequate for most purposes
    and more efficient than 16.
    * The Magick++ demo (compiled with QuantumDepth=8 and -O2) runs about
    1.8X faster under SPARC/Solaris than the same demo with ImageMagick
    5.5.4.
    * Colorspace transformations are much faster.
    * Grayscale/monochrome image handling is much faster.
    * PseudoClass image handling is faster.
    * Text annotations using FreeType are much faster.
    * Image file I/O is much faster.
    * RLE-compressed MIFF reading much faster.

  Code structure enhancements:
    * All utility support functions moved to magick/command.c in order to
    significantly reduce link dependencies, allowing statically-linked
    programs to be smaller.
    * Use of MogrifyImage() elminated except for by utilities.
    * Re-builds due to changes to <magick/image.h> reduced by splitting the
    header into multiple headers.
    * ISO C '99 typedefs (gm_int16_t, gm_uint16_t, gm_int32_t, gm_uint32_t,
    gm_int64_t, gm_uint64_t) are available for use.

  Feature enhancements:
    * Module loader always enabled for shared builds to allow extension.
    * Loading of arbitrary filter modules (via -process option) supported
    under Unix as well as Windows.
    * SVG coder allows specifying size and initial background color.
    * JPEG-2000 coder (JP2) updated to work with Jasper 1.7.
    * HWB and HSL image colorspace translation support.
    * JNG/MNG/PNG format support tracks ImageMagick version.
    * BMP encoder can write 16-color indexed BMPs now as well as 2-color
    BMPs (not restricted to monochrome).
    * TIFF decoder now includes optimized support for tiled and stripped
    TIFF.
    * The -random-threshold option (RandomThresholdImage()) is added to
    threshold an image to bilevel using random thresholding.

  Major bug fixes:
    * 100% successful test completion at all quantum depths (8/16/32).
    * A temporary file management subsystem is added to ensure that all
    temporary files are removed before program exit. Temporary files are
    created and used in a secure fashion to avoid the possibility that a
    "trojan" temporary file (e.g. a symbolic link, or a file containing
    unsafe content) is created before a delegate has the chance to write
    to it. The environment variable MAGICK_TMPDIR allows the user to
    specify where temporary files are created without altering where
    other programs create their temporary files. Temporary filenames are
    created in 8+3 format to hopefully be more acceptable to ralcgm.
    * When dithering is disabled, don't dither when converting to a
    PseudoClass, grayscale, or monochrome image. Disabling dithering
    may cause these translations to be much faster.
    * PICON format works with BLOBs.
    * No longer removes input file when pinging a FlashPIX file.
    * Arc drawing and texture fill fixes from ImageMagick.
    * Sample, scale and affine fixes from ImageMagick.
    * MIFF colormaps are now scaled properly while reading.
    * CMYK translation works for QuantumDepth=32.
    * ConstituteImage now works properly for grayscale images.
    * Built-in tilde expansion and filename globbing now works properly.
    * InitializeMagick now registers signal handlers to ensure that
    resources are released before program exit.  This helps avoid
    temporary file leaks due to the user using "CONTROL-C".
    * The installed <magick/magick_config.h> header now only contains
    the few definitions required by the API headers.  This should
    significantly reduce or eliminate conflicts with other package
    headers.

  Windows platform enhancements:
    * Configure updated for Visual C++ 7.0.
    * OLE object (ImageMagickObject) re-written to work with Visual C++ 7.0
    * New function, CropImageToHBITMAP(), to return a region of the image
    as a Windows HBITMAP.
    * Use vsnprintf to format strings under Windows (safer).

==============================================================
On November 19, 2002, GraphicsMagick was created as a fork of
ImageMagick, several days before the ImageMagick 5.5.2 release.

The objectives of GraphicsMagick are to:

  o Use an open development model.
  o Encourage new developers to join the project.
  o Avoid unnecessary source code "churn".
  o Establish and preserve a stable API.
  o Use efficient coding practices which result in fast code.
  o Improve memory efficiency.
  o Use a release process which assures a working product.
  o Maintain an accurate ChangeLog.


---------------------------------------------------------------------------
Copyright (C) 2003, 2007 GraphicsMagick Group

This program is covered by multiple licenses, which are described in
Copyright.txt. You should have received a copy of Copyright.txt with this
package; otherwise see http://www.graphicsmagick.org/www/Copyright.html.


